package com.jcg.prototypescopebean;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;


@SpringBootApplication
public class PrototypescopebeanApplication implements CommandLineRunner {

//    @Autowired
//    private MessageServiceFactory messageServiceFactory;
//    @Autowired
//    private MessageServiceProvider messageServiceProvider;
    
    @Autowired
    private MessageServiceFunction messageServiceFunction;


    public static void main(String[] args) {
        SpringApplication.run(PrototypescopebeanApplication.class, args);

    }

    @Override
    public void run(String... args) throws Exception {
        
        // Retrieve and use the prototype bean
        MessageService messageService1 = messageServiceFunction.createMessageService("Hello, World!");
        messageService1.printMessage();

        MessageService messageService2 = messageServiceFunction.createMessageService("Goodbye, World!");
        messageService2.printMessage();
        
        // Retrieve and use the prototype bean
//        MessageService messageService1 = messageServiceFactory.apply("Hello, World!");
//        messageService1.printMessage();
//
//        MessageService messageService2 = messageServiceFactory.apply("Goodbye, World!");
//        messageService2.printMessage();

        // Retrieve and use the prototype bean
//        MessageService messageService1 = messageServiceProvider.getMessageService("Hello, World!");
//        messageService1.printMessage();
//
//        MessageService messageService2 = messageServiceProvider.getMessageService("Goodbye, World!");
//        messageService2.printMessage();

//        MessageService messageService1 = messageServiceFactory.createMessageService("Hello, World!");
//        messageService1.printMessage();
//
//        MessageService messageService2 = messageServiceFactory.createMessageService("Goodbye, World!");
//        messageService2.printMessage();
    }
}
